UNIT graf19;

INTERFACE

USES
 crt,dos;

CONST
 maxX=319;
 maxY=199;
 aspect_ratio=0.95;

TYPE
 pistelista=^pistesolmu;
 pistesolmu=RECORD
    x,y:integer;
    next:pistelista;
   END;
 color=RECORD
    r,g,b:byte;
   END;

VAR
 bufferseg:word;
 fontheight,fontwidth,fontsize:integer;
 fontti:pointer;

PROCEDURE inigraf;
PROCEDURE graftila;
PROCEDURE tekstitila;
PROCEDURE nayttoon;
PROCEDURE aseta_puskuri(uusi:word);
PROCEDURE tyhjenna_puskuri;
PROCEDURE tayta_puskuri(vari:byte);
PROCEDURE ruutu;
PROCEDURE puskuriin;
FUNCTION  luepiste(x,y:integer):byte;
PROCEDURE piirrapiste(x,y:integer;vari:byte);
PROCEDURE luekuva(x1,y1,x2,y2:integer;puskuri:pointer);
PROCEDURE file2image(VAR f:file;VAR image:pointer);
PROCEDURE mov_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE and_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE xor_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE movnz_piirra(x1,y1:integer;puskuri:pointer);
PROCEDURE outchar(ch:char;x,y:integer;vari:byte);
PROCEDURE outtextXY(x,y:integer;teksti:string;vari:byte);
PROCEDURE hightextXY(x,y:integer;teksti:string;syv:integer;vari,varjovari:byte);
PROCEDURE instringXY(x,y:integer;VAR teksti:string;vari:byte);
PROCEDURE suorakaide(vyx,vyy,oax,oay:integer;vari:byte);
PROCEDURE ympyra(cx,cy,sade:integer;vari:byte);
PROCEDURE kiekko(cx,cy,sade:integer;vari:byte);
PROCEDURE xsuora(ax,ay,pituus:integer;vari:byte);
PROCEDURE ysuora(ax,ay,pituus:integer;vari:byte);
PROCEDURE kehys(vyx,vyy,oax,oay:integer;vari:byte);
PROCEDURE suora(ax,ay,lx,ly:integer;vari:byte);
PROCEDURE alias_suora(ax,ay,lx,ly:word; pankki:byte);
PROCEDURE varjokaide(vyx,vyy,oax,oay,syv:integer;vari,varjovari:byte);
PROCEDURE lue_fontti(fnimi:string);
PROCEDURE aseta_fontti(VAR p:pointer;uusheight,uuswidth:integer);
PROCEDURE fill_region(x,y:integer;bckgr,col:byte);
PROCEDURE set_color(col:byte;c:color);
PROCEDURE set_rgb(r,g,b:byte;col:byte);
PROCEDURE get_color(col:byte; VAR c:color);
PROCEDURE vretrace;

IMPLEMENTATION

PROCEDURE vretrace; assembler;
asm
   mov dx,3dah
@1:
   in  al,dx
   and al,08h
   jnz @1
@2:
   in  al,dx
   and al,08h
   jz  @2
end;


PROCEDURE get_color(col:byte; VAR c:color);
BEGIN
 Port[$3c7]:=col;
 WITH c DO
 BEGIN
  r:=Port[$3c9];
  g:=Port[$3c9];
  b:=Port[$3c9];
 END;
END;

PROCEDURE set_color(col:byte;c:color);
BEGIN
 Port[$3c8]:=col;
 WITH c DO
 BEGIN
  Port[$3c9]:=r;
  Port[$3c9]:=g;
  Port[$3c9]:=b;
 END;
END;

PROCEDURE set_rgb(r,g,b:byte;col:byte);
BEGIN
 Port[$3c8]:=col;
 Port[$3c9]:=r;
 Port[$3c9]:=g;
 Port[$3c9]:=b;
END;

PROCEDURE graftila;
BEGIN
 asm
  mov ax, 0013h
  int 10h
 end;
END;

PROCEDURE inigraf;
BEGIN
 graftila;
 bufferseg:=SegA000;
 fontti:=NIL;
END;

PROCEDURE tekstitila;
BEGIN
 asm
  mov ax, 0003h
  int 10h
 end;
END;

PROCEDURE nayttoon;
BEGIN
 bufferseg:=sega000;
END;

PROCEDURE aseta_puskuri(uusi:word);
BEGIN
 bufferseg:=uusi;
END;

PROCEDURE tyhjenna_puskuri;
VAR target:word;
BEGIN
 target:=bufferseg;
 asm
  push es
  push di
  xor ax, ax
  mov cx, $7d00
  mov dx, target
  mov es, dx
  mov di, ax
  rep stosw
  pop di
  pop es
 end;
END;

PROCEDURE tayta_puskuri(vari:byte);
VAR target:word;color:byte;
BEGIN
 target:=bufferseg;
 color:=vari;
 asm
  push es
  push di
  xor ax, ax
  mov dx, target
  mov di, ax
  mov es, dx
  mov ah, color
  mov cx, $7d00
  mov al, ah
  rep stosw
  pop di
  pop es
 end;
END;

PROCEDURE ruutu;
BEGIN
 asm
  push es
  push ds
  push si
  push di
  xor ax, ax
  mov si, ax
  mov di, ax
  mov dx, sega000
  mov es, dx
  mov dx, bufferseg
  mov ds, dx
  mov cx, $7d00
  rep movsw
  pop di
  pop si
  pop ds
  pop es
 end;
END;

PROCEDURE puskuriin;
BEGIN
 asm
  push es
  push ds
  push si
  push di
  xor ax, ax
  mov si, ax
  mov di, ax
  mov dx, bufferseg
  mov es, dx
  mov dx, sega000
  mov ds, dx
  mov cx, $7d00
  rep movsw
  pop di
  pop si
  pop ds
  pop es
 end;
END;

FUNCTION luepiste(x,y:integer):byte;
VAR apux,apuy,off,target:word;
BEGIN
 apuy:=y; apux:=x;
 target:=bufferseg;
 asm
  mov bx, apuy
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, apux
  mov off, ax
 end;
 luepiste:=Mem[target:off];
END;

PROCEDURE piirrapiste(x,y:integer;vari:byte);
VAR apux,apuy,off,target:word;
BEGIN
 apuy:=y; apux:=x;
 target:=bufferseg;
 asm
  mov bx, apuy
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, apux
  mov off, ax
 end;
 Mem[target:off]:=vari;
END;

PROCEDURE luekuva(x1,y1,x2,y2:integer;puskuri:pointer);
VAR i,j,sarakemaara,rivimaara:integer; off1,off2,off3,seg2,target:word;
BEGIN
 sarakemaara:=x2-x1+1;
 target:=bufferseg;
 rivimaara:=y2-y1+1;
 off1:=ofs(puskuri^);
 i:=x1; j:=y1;
 asm
  mov bx, j
  mov ax, bx
  mov cx, $0006
  shl ax, cl
  add ah, bl
  add ax, i
  mov off2, ax
 end;
 off3:=off1+2;
 seg2:=seg(puskuri^);
 MemW[seg2:off1]:=lo(sarakemaara);
 MemW[seg2:off1+1]:=lo(rivimaara);
 asm
   push ds
   push es
   push di
   push si
 end;
 for j:=1 to rivimaara do
 begin
  asm
   mov dx, target
   mov ds, dx
   mov di, seg2
   mov es, di
   mov di, off3
   mov si, off2
   mov cx, sarakemaara
   shr cx, 1
   rep movsw
   mov off3, di
   add off2, 320
  end;
 end;
 asm
   pop si
   pop di
   pop es
   pop ds
 end;
END;

PROCEDURE file2image(VAR f:file;VAR image:pointer);
VAR koko,koodi:integer;
BEGIN
 reset(f,1);
 koko:=filesize(f);
 getmem(image,koko+2);
 blockread(f,image^,koko,koodi);
END;

PROCEDURE mov_piirra(x1,y1:integer;puskuri:pointer);
VAR ax,ay,sarakemaara,rivimaara,i:integer;
    off1,off2,off3,seg2,offplus,target:word; b:byte;
BEGIN
 target:=bufferseg;
 seg2:=seg(puskuri^);
 off2:=ofs(puskuri^);
 b:=mem[seg2:off2];
 sarakemaara:=b;
 b:=mem[seg2:off2+1];
 rivimaara:=b;
 offplus:=sarakemaara;
 ax:=x1;
 ay:=y1;
 off1:=320*y1+x1;
 off3:=off2+2;
 if ax<0 then
 begin
  sarakemaara:=sarakemaara+ax;
  off1:=320*y1;
  off3:=off3-ax;
  ax:=0;
 end;
 if ax+sarakemaara>320 then sarakemaara:=320-ax;
 if ay<0 then
 begin
  rivimaara:=rivimaara+ay;
  off3:=off3+((-ay)*offplus);
  off1:=off1-(320*ay);
  ay:=0;
 end;
 if ay+rivimaara>200 then rivimaara:=200-ay;
 FOR i:=1 TO rivimaara DO
 BEGIN
  asm
   push es
   mov ax, target
   mov bx, off1
   mov cx, off3
   mov dx, seg2
   mov es, ax
   mov di, bx
   mov si, cx
   mov cx, sarakemaara
   push ds
   mov ds, dx
   rep movsb
   pop ds
   pop es
  end;
  off1:=off1+320;
  off3:=off3+offplus;
 END;
END;

PROCEDURE and_piirra(x1,y1:integer;puskuri:pointer);
VAR ax,ay,sarakemaara,rivimaara,i:integer;
    off1,off2,off3,seg2,offplus,target:word; b:byte;
BEGIN
 target:=bufferseg;
 seg2:=seg(puskuri^);
 off2:=ofs(puskuri^);
 b:=mem[seg2:off2];
 sarakemaara:=b;
 b:=mem[seg2:off2+1];
 rivimaara:=b;
 offplus:=sarakemaara;
 ax:=x1;
 ay:=y1;
 off1:=320*y1+x1;
 off3:=off2+2;
 if ax<0 then
 begin
  sarakemaara:=sarakemaara+ax;
  off1:=320*y1;
  off3:=off3-ax;
  ax:=0;
 end;
 if ax+sarakemaara>320 then sarakemaara:=320-ax;
 if ay<0 then
 begin
  rivimaara:=rivimaara+ay;
  off3:=off3+((-ay)*offplus);
  off1:=off1-(320*ay);
  ay:=0;
 end;
 if ay+rivimaara>200 then rivimaara:=200-ay;
 FOR i:=1 TO rivimaara DO
 BEGIN
  asm
   push es
   mov ax, target
   mov bx, off1
   mov cx, off3
   mov dx, seg2
   mov es, ax
   mov di, bx
   mov si, cx
   mov cx, sarakemaara
   push ds
   mov ds, dx
  @luuppi:
   mov al, [ds:si]
   and [es:di], al
  @ohi:
   inc si
   inc di
   loop @luuppi
   pop ds
   pop es
  end;
  off1:=off1+320;
  off3:=off3+offplus;
 END;
END;

PROCEDURE xor_piirra(x1,y1:integer;puskuri:pointer);
VAR ax,ay,sarakemaara,rivimaara,i:integer;
    off1,off2,off3,seg2,offplus,target:word; b:byte;
BEGIN
 target:=bufferseg;
 seg2:=seg(puskuri^);
 off2:=ofs(puskuri^);
 b:=mem[seg2:off2];
 sarakemaara:=b;
 b:=mem[seg2:off2+1];
 rivimaara:=b;
 offplus:=sarakemaara;
 ax:=x1;
 ay:=y1;
 off1:=320*y1+x1;
 off3:=off2+2;
 if ax<0 then
 begin
  sarakemaara:=sarakemaara+ax;
  off1:=320*y1;
  off3:=off3-ax;
  ax:=0;
 end;
 if ax+sarakemaara>320 then sarakemaara:=320-ax;
 if ay<0 then
 begin
  rivimaara:=rivimaara+ay;
  off3:=off3+((-ay)*offplus);
  off1:=off1-(320*ay);
  ay:=0;
 end;
 if ay+rivimaara>200 then rivimaara:=200-ay;
 FOR i:=1 TO rivimaara DO
 BEGIN
  asm
   push es
   mov ax, target
   mov bx, off1
   mov cx, off3
   mov dx, seg2
   mov es, ax
   mov di, bx
   mov si, cx
   mov cx, sarakemaara
   push ds
   mov ds, dx
  @luuppi:
   mov al, [ds:si]
   xor [es:di], al
  @ohi:
   inc si
   inc di
   loop @luuppi
   pop ds
   pop es
  end;
  off1:=off1+320;
  off3:=off3+offplus;
 END;
END;

PROCEDURE movnz_piirra(x1,y1:integer;puskuri:pointer);
VAR ax,ay,sarakemaara,rivimaara,i:integer;
    off1,off2,off3,seg2,offplus,target:word; b:byte;
BEGIN
 target:=bufferseg;
 seg2:=seg(puskuri^);
 off2:=ofs(puskuri^);
 b:=mem[seg2:off2];
 sarakemaara:=b;
 b:=mem[seg2:off2+1];
 rivimaara:=b;
 offplus:=sarakemaara;
 ax:=x1;
 ay:=y1;
 off1:=320*y1+x1;
 off3:=off2+2;
 if ax<0 then
 begin
  sarakemaara:=sarakemaara+ax;
  off1:=320*y1;
  off3:=off3-ax;
  ax:=0;
 end;
 if ax+sarakemaara>320 then sarakemaara:=320-ax;
 if ay<0 then
 begin
  rivimaara:=rivimaara+ay;
  off3:=off3+((-ay)*offplus);
  off1:=off1-(320*ay);
  ay:=0;
 end;
 if ay+rivimaara>200 then rivimaara:=200-ay;
 FOR i:=1 TO rivimaara DO
 BEGIN
  asm
   push es
   mov ax, target
   mov bx, off1
   mov cx, off3
   mov dx, seg2
   mov es, ax
   mov di, bx
   mov si, cx
   mov cx, sarakemaara
   push ds
   mov ds, dx
  @luuppi:
   mov al, [ds:si]
   and al, al
   jz @ohi
   mov [es:di], al
  @ohi:
   inc si
   inc di
   loop @luuppi
   pop ds
   pop es
  end;
  off1:=off1+320;
  off3:=off3+offplus;
 END;
END;

PROCEDURE outchar(ch:char;x,y:integer;vari:byte);
VAR poikkeutus,fontseg,fontoff,target:word;i:integer;col,apu:byte;
BEGIN
 poikkeutus:=320*y+x;
 col:=vari;
 target:=bufferseg;
 fontseg:=seg(fontti^);
 fontoff:=ofs(fontti^)+fontsize*ord(ch);
 FOR i:=1 TO fontwidth DO
 BEGIN
  asm
   push es
   push dx
   mov dx, fontseg
   mov es, dx
   mov bx, fontoff
   mov ah, [es:bx]
   mov cx, fontheight
   cmp cx, $0008
   je @vain8
   inc bx
   mov al, [es:bx]
   mov fontoff, bx
   @vain8:
   mov dx, target
   mov es, dx
   mov bx, poikkeutus
   mov dl, col
   @pixeliluuppi:
   shl ax, 1
   jnc @ohi
   mov [es:bx], dl
   @ohi:
   add bx, 320
   loop @pixeliluuppi
  end;
  inc(poikkeutus);
  inc(fontoff);
 END;
END;

PROCEDURE outtextXY(x,y:integer;teksti:string; vari:byte);
VAR paikkax,paikkay,i,pituus,raja:integer;
BEGIN
 paikkax:=x; paikkay:=y;
 i:=1; pituus:=Length(teksti); raja:=maxX-fontwidth+1;
 WHILE (i<=pituus) AND (paikkax<=raja) DO
 BEGIN
  outchar(teksti[i],paikkax,paikkay,vari);
  paikkax:=paikkax+fontwidth+1;
  i:=i+1;
 END;
END;

PROCEDURE hightextXY(x,y:integer;teksti:string;syv:integer;vari,varjovari:byte);     
VAR i:integer;
BEGIN
 FOR i:=syv DOWNTO 1 DO
  outtextXY(x+i,y,teksti,varjovari);
 outtextXY(x,y,teksti,vari);
END;

PROCEDURE instringXY(x,y:integer;VAR teksti:string;vari:byte);
VAR dummy:char; i,pituus,paikkax,paikkay:integer; pohjavari:byte;
BEGIN
 teksti:='';
 pohjavari:=luepiste(x,y);
 paikkax:=x; paikkay:=y;
 pituus:=0;
 REPEAT
  REPEAT
   outchar('_',paikkax,paikkay,vari);
   dummy:=readkey;
   outchar(chr(178),paikkax,paikkay,pohjavari);
  UNTIL ord(dummy)<>0;
  CASE dummy OF
  chr(13),chr(10):BEGIN END;
  chr(27):BEGIN
           FOR i:=pituus DOWNTO 1 do
           BEGIN
            paikkax:=paikkax-fontwidth-1;
            outchar(chr(178),paikkax,paikkay,pohjavari);
           END;
           teksti:='';
           paikkax:=x;
           pituus:=0;
          END;
  chr(8):IF pituus>0 THEN
         BEGIN
          paikkax:=paikkax-fontwidth-1;
          outchar(chr(178),paikkax,paikkay,pohjavari);
          delete(teksti,pituus,1);
          pituus:=pituus-1;
         END;
  ELSE BEGIN
        outchar(dummy,paikkax,paikkay,vari);
        teksti:=teksti+dummy;
        paikkax:=paikkax+fontwidth+1;
        pituus:=pituus+1;
       END;
  END;
 UNTIL dummy=chr(13);
END;

PROCEDURE xsuora(ax,ay,pituus:integer;vari:byte);
VAR l:integer;off,target:word;col:byte;
BEGIN
 l:=pituus;
 IF ax<0 THEN BEGIN l:=l+ax; ax:=0 END;
 IF (l>0) AND (ax<320) AND (ay>=0) AND (ay<200) THEN
 BEGIN
 target:=bufferseg;
 off:=320*ay+ax;
 IF l+ax>320 THEN l:=320-ax;
 col:=vari;
 asm
  push es
  push dx
  mov dx, target
  mov es, dx
  mov dx, off
  mov di, dx
  mov cx, l
  mov al, col
  rep stosb
  pop dx
  pop es
 end;
 END;
END;

PROCEDURE ysuora(ax,ay,pituus:integer;vari:byte);
VAR l:integer;off,target:word;col:byte;
BEGIN
 l:=pituus;
 IF ay<0 THEN BEGIN l:=l+ay; ay:=0 END;
 IF (ax>=0) AND (ax<320) AND (l>0) AND (ay<200) THEN
 BEGIN
 off:=320*ay+ax;
 target:=bufferseg;
 IF l+ay>200 THEN l:=200-ay;
 col:=vari;
 asm
  push es
  mov dx, target
  mov es, dx
  mov dx, off
  mov di, dx
  mov al, col
  mov bx, $0140
  mov cx, l
 @luuppi:
  mov [es:di], al
  add di, bx
  loop @luuppi
  pop es
 end;
 END;
END;

PROCEDURE kehys(vyx,vyy,oax,oay:integer;vari:byte);
VAR xpit,ypit:integer;
BEGIN
 xpit:=oax+1-vyx;
 ypit:=oay+1-vyy;
 xsuora(vyx,vyy,xpit,vari);
 xsuora(vyx,oay,xpit,vari);
 ysuora(vyx,vyy,ypit,vari);
 ysuora(oax,vyy,ypit,vari);
END;

PROCEDURE suorakaide(vyx,vyy,oax,oay:integer;vari:byte);
VAR target,off,korkeus,l:word;col:byte;
BEGIN
 korkeus:=oay+1-vyy;
 l:=oax+1-vyx;
 target:=bufferseg;
 off:=320*vyy+vyx;
 col:=vari;
 asm
  push es
  mov dx, target
  mov es, dx
  mov al, col
  mov ah, al
  mov dx, off
  push dx
  mov cx, korkeus
 @luuppi:
  mov di, dx
  push cx
  mov cx, l
  mov bx, dx
  and bx, 1
  jz @alkuparillinen
  stosb
  dec cx
 @alkuparillinen:
  mov bx, cx
  shr cx, 1
  and bx, 1
  rep stosw
  or  bx, bx
  jz @loppuparillinen
  stosb
 @loppuparillinen:
  pop cx
  pop dx
  add dx, 320
  push dx
  loop @luuppi
  pop dx
  pop es
 end;
END;

PROCEDURE x_line(ax,ay,lx,ly:integer;vari:byte);
{* ax < lx ja kulmakerroin in [-1,1] *}
VAR target,off1,off2:word;incr:byte;kk,pituus:integer;
    sx,sy:real;
BEGIN
 target:=bufferseg;
 off1:=(320*ay+ax);
 pituus:=lx-ax;
 sx:=pituus;
 sy:=ly-ay;
 kk:=round(sy*256/sx);
 IF kk>=0 THEN
 BEGIN
  IF kk>255 THEN kk:=255;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add bl, dl
   jnc @ohi
   add di, 0140h
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
 IF kk<0 THEN
 BEGIN
  IF kk<-255 THEN kk:=-255;
  kk:=-kk;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add bl, dl
   jnc @ohi
   sub di, 0140h
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
END;

PROCEDURE y_line(ax,ay,lx,ly:integer;vari:byte);
{* ay < ly ja kulmakerroin not in [-1,1] *}
VAR target,off1,off2:word;incr:byte;kk,pituus:integer;
    sx,sy:real;
BEGIN
 target:=bufferseg;
 off1:=(320*ay+ax);
 pituus:=ly-ay;
 sy:=pituus;
 sx:=lx-ax;
 kk:=round(sx*256/sy);
 IF kk>=0 THEN
 BEGIN
  IF kk>255 THEN kk:=255;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add di, 013fh
   add bl, dl
   jnc @ohi
   inc di
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
 IF kk<0 THEN
 BEGIN
  IF kk<-255 THEN kk:=-255;
  kk:=-kk;
  incr:=lo(kk);
  asm
   push es
   mov dx, target
   mov es, dx
   mov dx, off1
   mov di, dx
   mov cx, pituus
   mov al, [vari]
   mov bl, 80h
   mov dl, incr
   cld
   @silmukka:
   stosb
   add di, 013fh
   add bl, dl
   jnc @ohi
   dec di
   @ohi:
   loop @silmukka
   pop es
  end;
 END;
END;

PROCEDURE suora(ax,ay,lx,ly:integer;vari:byte);
VAR bx,by,i,pituus,sx,sy:integer;
 x,y,min,max,k,b:real;
BEGIN
 sx:=lx-ax;
 sy:=ly-ay;
 IF sx=0 THEN
 BEGIN
  IF ly<ay THEN
  BEGIN
   bx:=ax;ax:=lx;lx:=bx;
   by:=ay;ay:=ly;ly:=by;
  END;
  ysuora(ax,ay,ly-ay+1,vari)
 END
 ELSE IF sy=0 THEN
 BEGIN
  IF lx<ax THEN
  BEGIN
   bx:=ax;ax:=lx;lx:=bx;
   by:=ay;ay:=ly;ly:=by;
  END;
  xsuora(ax,ay,lx-ax+1,vari);
 END
 ELSE
 BEGIN
  k:=sy/sx;
  b:=ay-k*ax;
  IF sx<0 THEN
  BEGIN
   bx:=ax;ax:=lx;lx:=bx;
   by:=ay;ay:=ly;ly:=by;
  END;
  IF ax<0 THEN
  BEGIN
   ax:=0; ay:=round(b);
  END;
  IF lx>319 THEN
  BEGIN
   lx:=319; ly:=round(k*lx+b);
  END;
  min:=ay; max:=ay;
  IF ay<ly THEN max:=ly ELSE min:=ly;
  IF (ax<lx) AND (max>0) AND (min<199) THEN
  BEGIN
   IF ay<0 THEN
   BEGIN
    ay:=0; ax:=round(-b/k);
   END;
   IF ly<0 THEN
   BEGIN
    ly:=0; lx:=round(-b/k);
   END;
   IF ay>199 THEN
   BEGIN
    ay:=199; ax:=round((199-b)/k);
   END;
   IF ly>199 THEN
   BEGIN
    ly:=199; lx:=round((199-b)/k);
   END;
   sx:=lx-ax;
   sy:=ly-ay;
   pituus:=abs(sx)+abs(sy);
   IF pituus>0 THEN
   BEGIN
    IF abs(sx)>=abs(sy) THEN x_line(ax,ay,lx,ly,vari)
    ELSE
    BEGIN
     IF ly<ay THEN
     BEGIN
      bx:=ax;ax:=lx;lx:=bx;
      by:=ay;ay:=ly;ly:=by;
     END;
     y_line(ax,ay,lx,ly,vari)
    END;
   END;
  END;
 END;
END;

PROCEDURE ympyra(cx,cy,sade:integer;vari:byte);
VAR i,x,y,pituus:integer;kulma,askel:real;
BEGIN
 pituus:=8*sade;
 askel:=6.283/pituus;
 kulma:=0.0;
 FOR i:=0 TO pituus DO
 BEGIN
  x:=cx+round(sade*cos(kulma));
  y:=cy+round(sade*sin(kulma)*aspect_ratio);
  kulma:=kulma+askel;
  piirrapiste(x,y,vari);
 END;
END;

PROCEDURE kiekko(cx,cy,sade:integer;vari:byte);
VAR x,y:real;i,j,korkeus,pituus:integer;
BEGIN
 korkeus:=round(sade*aspect_ratio);
 FOR i:=cy-korkeus TO cy+korkeus DO
 BEGIN
  y:=(i-cy)/aspect_ratio;
  x:=sade*sade-y*y;
  IF x>0.0 THEN
  BEGIN
   x:=sqrt(x);
   j:=round(x+0.2); pituus:=2*j+1;
   xsuora(cx-j,i,pituus,vari);
  END;
 END;
END;

PROCEDURE lue_fontti(fnimi:string);
VAR f:FILE; maara,koodi:integer; apu:byte;
BEGIN
 assign(f, fnimi+'.fon');
 reset(f,1);
 blockread(f,apu,1,koodi);
 fontwidth:=apu;
 blockread(f,apu,1,koodi);
 fontheight:=apu;
 fontsize:=fontwidth*(fontheight SHR 3);
 maara:=(fontsize SHL 8);
 getmem(fontti,maara);
 blockread(f,fontti^,maara,koodi);
END;

PROCEDURE aseta_fontti(VAR p:pointer;uusheight,uuswidth:integer);
BEGIN
 fontti:=p;
 fontheight:=uusheight;
 fontwidth:=uuswidth;
 fontsize:=fontwidth*(fontheight SHR 3);
END;

PROCEDURE varjokaide(vyx,vyy,oax,oay,syv:integer;vari,varjovari:byte);    
VAR i:integer;
BEGIN
 FOR i:=1 TO syv DO
  kehys(vyx+i,vyy+i,oax+i,oay+i,varjovari);
 suorakaide(vyx,vyy,oax,oay,vari);
END;

PROCEDURE fill_region(x,y:integer;bckgr,col:byte);
VAR pl1,pl2:pistelista;curx,cury:integer;uusi:boolean;
BEGIN
 new(pl1);
 pl1^.next:=NIL;
 pl1^.x:=x;
 pl1^.y:=y;
 IF (x>=0) AND (x<320) AND (y>=0) AND (y<200) THEN
 WHILE pl1<>NIL DO
 BEGIN
  curx:=pl1^.x;
  cury:=pl1^.y;
  piirrapiste(curx,cury,col);
  uusi:=false;
  IF (cury>0) AND (luepiste(curx,cury-1)=bckgr) THEN
  BEGIN
   uusi:=true;
   dec(cury);
  END
  ELSE
   IF (curx<319) AND (luepiste(curx+1,cury)=bckgr) THEN
   BEGIN
    uusi:=true;
    inc(curx);
   END
   ELSE
    IF (cury<199) AND (luepiste(curx,cury+1)=bckgr) THEN
    BEGIN
     uusi:=true;
     inc(cury);
    END
    ELSE
     IF (curx>0) AND (luepiste(curx-1,cury)=bckgr) THEN
     BEGIN
      uusi:=true;
      dec(curx);
     END;
  IF uusi THEN
  BEGIN
   new(pl2);
   pl2^.x:=curx;
   pl2^.y:=cury;
   pl2^.next:=pl1;
   pl1:=pl2;
  END
  ELSE
  BEGIN
   pl2:=pl1;
   pl1:=pl1^.next;
   dispose(pl2);
  END;
 END;
END;

procedure alias_suora(ax,ay,lx,ly:word; pankki:byte);
var b1,b2:byte; x1,y1,d1,offset,incr:word; i,j,dx,dy:integer;
    k,b:real;
begin
 if ax>lx then
 begin
  i:=lx; lx:=ax; ax:=i;
  i:=ly; ly:=ay; ay:=i;
 end;
 if (ax<320) and (lx<320) and (ay<200) and (ly<200) then
 begin
 offset:=320*ay+ax;
 dx:=lx-ax;
 dy:=ly-ay;
 if dy=0 then xsuora(ax,ay,lx-ax+1,pankki);
 if (dy>0) and (dy=dx) then
 begin
  mem[bufferseg:offset]:=pankki;
  for j:=1 to dx do
  begin
   inc(offset,321);
   mem[bufferseg:offset]:=pankki;
  end;
 end;
 if (dy>0) and (dy<dx) then
 begin
  mem[bufferseg:offset]:=pankki;
  y1:=$0000;
  d1:=(longint(dy)*256) div dx;
  for j:=1 to dx do
  begin
   inc(offset);
   inc(y1,d1);
   b1:=y1 shr 4;
   b2:=$0f xor b1;
   mem[bufferseg:offset]:=pankki+b1;
   mem[bufferseg:offset+320]:=pankki+b2;
   if y1+d1>=256 then
   begin
    dec(y1,256);
    inc(offset,320);
   end;
  end;
 end;
 if (dy<0) and (-dy=dx) then
 begin
  mem[bufferseg:offset]:=pankki;
  for j:=1 to dx do
  begin
   dec(offset,319);
   mem[bufferseg:offset]:=pankki;
  end;
 end;
 if (dy<0) and (-dy<dx) then
 begin
  mem[bufferseg:offset]:=pankki;
  y1:=$0000;
  d1:=(longint(-dy)*256) div dx;
  for j:=1 to dx do
  begin
   inc(offset);
   inc(y1,d1);
   b1:=y1 shr 4;
   b2:=$0f xor b1;
   mem[bufferseg:offset]:=pankki+b1;
   mem[bufferseg:offset-320]:=pankki+b2;
   if y1+d1>=256 then
   begin
    dec(y1,256);
    dec(offset,320);
   end;
  end;
 end;
 if dx=0 then ysuora(ax,ay,ly-ay+1,pankki);
 if (dy>0) and (dx<dy) then
 begin
  mem[bufferseg:offset]:=pankki;
  x1:=$0000;
  d1:=(longint(dx)*256) div dy;
  for j:=1 to dy do
  begin
   inc(offset,320);
   inc(x1,d1);
   b1:=x1 shr 4;
   b2:=$0f xor b1;
   mem[bufferseg:offset]:=pankki+b1;
   mem[bufferseg:offset+1]:=pankki+b2;
   if x1+d1>=256 then
   begin
    dec(x1,256);
    inc(offset);
   end;
  end;
 end;
 if (dy<0) and (-dy>dx) then
 begin
  mem[bufferseg:offset]:=pankki;
  x1:=$0000;
  d1:=(longint(dx)*256) div (-dy);
  for j:=1 to (-dy) do
  begin
   dec(offset,320);
   inc(x1,d1);
   b1:=x1 shr 4;
   b2:=$0f xor b1;
   mem[bufferseg:offset]:=pankki+b1;
   mem[bufferseg:offset+1]:=pankki+b2;
   if x1+d1>=256 then
   begin
    dec(x1,256);
    inc(offset);
   end;
  end;
 end
 end
end;

BEGIN
END.
